<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: nodeScripts/socketCom.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: nodeScripts/socketCom.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>
/**
 * &lt;h3>Communication via socket.io&lt;/h3>
 * &lt;table>
 *   &lt;tr>&lt;th>socket event emit&lt;/th>&lt;th>socket event on (receive request)&lt;/th>&lt;th>description&lt;/th>&lt;/tr>
 *   &lt;tr>&lt;td>name:connection&lt;br>call:socket.connect();&lt;br>&lt;br>@see [client: function selector view (dispatcher.html)]{@link HTML/dispatcher.html}&lt;/p>&lt;/td>&lt;td>name:connection&lt;br>call:io.on('connection',...&lt;br>&lt;br>@see [server : connect server to socket]{@link c_socketCom_server.c_1_socketfunction.event:connection}&lt;/td>&lt;td>function selection web client starts the communication&lt;/td>&lt;/tr>
 * &lt;/table>
 * &lt;p> The socketCom module consists of only one function which is described in the following namespace: &lt;/p>
 * &lt;p>@see {@link c_socketCom_server.c_1_socketfunction}&lt;/p>
 * &lt;p>Details are described in the tutorial&lt;/p> 
 * &lt;p>See {@tutorial staticEngineModel}&lt;/p>
 * &lt;h3>Parent module&lt;/h3>
 * &lt;p> Index.js See {@link module:index}&lt;/p>
 * &lt;h3>Child modules&lt;/h3>
 * &lt;p>See {@link module:f_getPostgresData_server}&lt;/p>
 * &lt;p>See {@link module:g_setPostgresData_server}&lt;/p>
 * &lt;p>See {@link module:j_updatePostgresData_server}&lt;/p>
 * &lt;p>See {@link module:h_deletePostgresData_server}&lt;/p>
 * &lt;p>See {@link module:k_select-stimulation_client}&lt;/p>
 * &lt;p>@see {@link c_socketCom_server.c_1_socketfunction.event:getTable}&lt;/p>
 * 
 * @module c_socketCom_server
 */

/** @function 
 * @description exported function : needed to select and visualize audio data
 * &lt;p> - the internals of this function are described in the linked namespace
 * &lt;p>{@link c_socketCom_server.c_1_socketfunction}
*/
module.exports = function(server)
{   
 /**
     * Foo object (@see: {@link module:socketCom~function})
     * @name c_socketCom_server
     * @inner
     * @private
     * @memberof module:socketCom
     * @property {Object} c_socketCom_server - The foo object
     * @property {Object} c_socketCom_server.c_1_socketfunction - The bar object     
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected - The bar object     
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata - The bar object     
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata - The bar object  
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable - The bar object
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve - The bar object
     * @property {Object} c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData - The bar object
     */
 
   /**
     * This namespace describes the function body of the server sided socket.io
     * interface
     * @memberof c_socketCom_server
     * @type {object}
     * @namespace c_socketCom_server.c_1_socketfunction
     * 
     */

   /**
    * socket io object created upon the existing http server 
    * @memberof c_socketCom_server.c_1_socketfunction
    * @type {object}
    * @see {@link socket.io} 
    */
    const io = require('socket.io')(server);
    /**
     * Getter function of postgres data
    * @memberof c_socketCom_server.c_1_socketfunction
    * @type {function}
    * @see {@link module:f_getPostgresData_server}
    */
    const pg = require('./getPostgresData.js');
    /**
    * @memberof c_socketCom_server.c_1_socketfunction
    * @param {object}
    */
    const pgSet = require('./setPostgresData.js');
    const pgUpdate = require('./updatePostgresData.js');
    /**
    * @memberof c_socketCom_server.c_1_socketfunction
    * @param {object}
    */
    const pgDel = require('./deletePosgresData.js');
    /**
    * @memberof c_socketCom_server.c_1_socketfunction
    * @param {object}
    */
    const getWav = require('./getWavFilesFromLinux.js');
    
    /**     
     * @memberof c_socketCom_server.c_1_socketfunction    
     * @event connection
     * @type {object}
     * @property {object} connection - the connection callback opens up a chain of socket events.     
     * &lt;br>&lt;br>@see {@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected}
     */

    io.on('connection', (socket) => {

    /**
     * This namespace describes the function body of the server sided socket.io
     * callback function on the connection event. Each sub-namespace represents a callback function
     * on a socket event which occurs afters the socket is connected. Follow the links with the short 
     * description or the namespace names to get the details (follow the link to find the details about the server strategy).
     * 
     * The following steps are executed by the server on a socket connection : 
     * &lt;li>[emit 1000ms periodic socket.io event named 'time']{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:time}&lt;/li>
     * &lt;li>[send postgres table "ThermoBaseDataStationary" to the client by emitting the socket.io event 'thermdata']{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.pg}&lt;/li>
     * 
     * 
     * 
     * @memberof c_socketCom_server.c_1_socketfunction
     * @type {object}
     * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
     * 
     * @see [server: start processing new set of formatted curve data]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData}
     * &lt;br>[server: store formatted 3d table data to postgres]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata}
     * &lt;br>[server: store formatted 2d curve data to postgres]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata}
     * &lt;br>[server: read raw table data from postgres and send it to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable}
     * &lt;br>[server: read raw curve data from postgres and send it to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve}
     * &lt;br>[server: read stimulation data from file/postgres and send it to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData}
     * 
     */
     
        console.log('Client connected');
        console.log(socket.handshake.headers.host);

        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @function setInterval
          * @param {function} socket.emit
          * @param {number} 1000
          * @description creates a periodic time interval which emits the 'time'
          * event on the socket.io interface. The 'time' event triggers the 
          * simulation view of the client and starts a new calculation in the 
          * client perspective.
          * @see [time event]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:time}
          */
        setInterval(() => socket.emit('time', 
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event time
          * @type {object}
          * @property {method} toTimeString - convert current system time to string          
          * @description [client : simulation view time event]{@link n_create_simulation_view_client.n_1_create_simulation_view.event:periodic_time}          
          */

          new Date().toTimeString()),
         1000);
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event disconnect
          * @type {object}   
          * @description ouput of the disconnected status on the standard console  
          */
        socket.on('disconnect', () => console.log('Client disconnected'));
           /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @function pg
          * @param {object} socket socket object
          * @param {string} ThermoBaseDataStationary name of the database
          * @param {string} thermdata name of the emitted event
          * @description reads the ThermoBaseDataStationary data table 
          * to the "function selection" view of the client. 
          * &lt;br>&lt;br> Find the client's read event callback by following the link
          * &lt;br>[client : process thermodynamic engine data]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client}
          * &lt;br>&lt;br> Find the precise description of the postgres interface by following the link. 
          * &lt;br>[server : postgres interface - get data]{@link module:f_getPostgresData_server}          
          */
        pg(socket,"ThermoBaseDataStationary",'thermdata');
//------------------------------------------------------------------------------------------
// Start of initNewData event
//------------------------------------------------------------------------------------------        
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event initNewData
          * @type {function}
          * @property {function} () Initializes postgres for a new set of formatted
          * calibration curves
          * @description by clicking on curve typed engine cal. data in the function selection view (dispatcher.html) 
          * the click event handler emits the 'initNewData' event. It starts the processing of a set of curves
          * like the pressure ratio across a compressor wheel. The serves reacts on this event by initializing 
          * new data structures and setting the "ActiveView" parameter to "curve". &lt;br>
          * &lt;br> Find the details in the link. 
          * &lt;br>[server: start processing new set of formatted curve data]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData}
          */
        socket.on('initNewData', function(){  
          /**
          * This namespace describes the function body of the server sided 'initNewData'
          * event. It initializes the calibration data structure by setting the
          * 'ActivateView' object and postgres table to 'curve' and deleting the
          * postgres data table 'ThermoCalDataCurves'. 
          * There are 2 events which fill content into the curve data structures : 
          * &lt;li>'initNewData'&lt;/li>
          * &lt;li>'curvedata'&lt;/li>
          * &lt;br>
          * The 'curvedata' event processes all curves which belong to a data element,
          * e.g. the curves of the pressure across the compressor wheel. 
          * &lt;br>&lt;br>Find the details about the callback function which triggers those events in 
          * the following link. &lt;br>
          * [client : process data for turbine and compressor]{@link data.d_1_handler.forLoopTurbineCompressor}
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
          * 
          */ 

          /**
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
          * @typedef {object} type
          * @property {string} view status string : 'contant', 'curve' or 'map'
          * 
          */         
         
          /**
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
          * @type {type}
          * @description initialized by 'curve'
          */         
          var type = {}

          type.view = 'curve';

          /**          
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
          * @function pgUpdate
          * @param {string} ActiveView postgres table
          * @param {string} View postgres column in table
          * @param {type} type type object - indicates "curve" view in given case
          * @description Set active view in postgres to "curve".
          *  @see {@link module:j_updatePostgresData_server}
          */    
          pgUpdate('ActiveView','View',type);                           

          /**          
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData
          * @function pgDel
          * @param {string} ThermoCalDataCurves Database
          * @param {string} ThermoCalDataCurves Table          
          * @description delete previous calibration curves because this is the first step of the definition of a new set of curves. 
          * @see {@link module:h_deletePostgresData_server}
          */    
          pgDel("ThermoCalDataCurves","ThermoCalDataCurves");
        });
//------------------------------------------------------------------------------------------
// End of initNewData event
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
// Start of tabledata event
//------------------------------------------------------------------------------------------
        
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event tabledata
          * @type {object}
          * @property {function} () Changes the following postgres data :
          * &lt;li>Indicate map view as active view&lt;/li> 
          * &lt;li>delete previous map&lt;/li>
          * &lt;li>add new map&lt;/li>  
          * @see [server: store formatted 3d table data to postgres]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata}   
          * @description tabledata event triggers a callback function which stores formatted 3d table data to postgres
          */
        socket.on('tabledata', function(data){
          
        /**
          * This namespace describes the function body of the server sided socket.io
          * interface
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata
          * 
          */

          /**
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata
          * @type {type}
          * @description if data length is greater than 2, then the 'ActiveType' equals 'map' otherwise
          * is is 'const'. The type 'curve' is set in a separate event callback.
          */       

          var type = {}
          if(data.length>2)
          {
            type.view = 'map';  
          }
          else 
          {
            type.view = 'const';
          }
          
          pgUpdate('ActiveView','View',type);                         
           /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata    
          * @function pgDel
          * @param {string} database name of the database
          * @param {string} event name of the emitted event
          * @description triggers a query in the postgres database which eventually
          * eventually loads the found data
          */
          pgDel("ThermoCalDataMaps","ThermoCalDataMaps");

          /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata        
          * @function pgSet
          * @param {string} database name of the database
          * @param {string} event name of the emitted event
          * @description triggers a query in the postgres database which eventually
          * eventually loads the found data
          */
          pgSet("ThermoCalDataMaps","Maps",data);
        }); 
//------------------------------------------------------------------------------------------
// End of tabledata event
//------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------
// Start of curvedata event
//------------------------------------------------------------------------------------------

        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event curvedata
          * @type {object}
          * @property {function} function(data) store formatted curve data to postgres.  
          * @see [server: store formatted 2d curve data to postgres]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata}   
          * @description set of curves is received from the client by this socket.io event and stored to postgres. 
          * &lt;br>follow the link to find the details about callback function
          */ 
        socket.on('curvedata', function(data){   
          
          /**
          * This namespace describes the body of the callback function which is called
          * on the 'curvedata' event. The server sided callback receives formatted
          * curve data from the engine model and stores it in a corresponding postgres
          * table "ThermoCalDataCurves".
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata
          * 
          */    

         /**     
           * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata    
           * @function pgSet
           * @param {string} ThermoCalDataCurves name of the postgres table
           * @param {string} Curves name of the column in the postgres table
           * @description set "Curves" column in postgres table "ThermoCalDataCurves".
           * &lt;br>Follow the link to find the details about the postgres setter function
           * @see {@link module:g_setPostgresData_server}
           */
          pgSet("ThermoCalDataCurves","Curves",data);
          
        });
//------------------------------------------------------------------------------------------
// End of curvedata event
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
// Start of getTable event
//------------------------------------------------------------------------------------------
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event getTable
          * @type {object}
          * @property {function} getPostGresData Calls postgres getter function with the arguements 'sendTable'. 'sendTable' 
          * is the name of the emitted event which conveys the postgres data table ThermoCalDataMaps to the web client. 
          * @description request event coming from the function selection view. It is triggered by the request button 
          * for a specific 3d table editor and requests the raw data of a selected map to send it to the 3d view.
          * @see [server: read raw table data from postgres and send it to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable}
          */ 
        socket.on('getTable',function(){
          /**
          * This namespace describes the function body of the server sided socket.io
          * interface
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable
          * 
          */ 
         
          
        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable    
          * @function pg
          * @param {string} ThermoCalDataMaps postgres table
          * @param {string} sendTable name of the socket event
          * @description triggers a query in the postgres database which eventually
          * eventually loads the found data via the 'sendTable' event of socket.io.  
          */
          pg(socket,"ThermoCalDataMaps",'sendTable');          
        });
//------------------------------------------------------------------------------------------
// End of getTable event
//------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------
// Start of getCurve event
//------------------------------------------------------------------------------------------

        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event getCurve
          * @type {object}
          * @property {function} () get currently selected set of curves from postgres
          * @description selected curve of function selector view is requested by the client.
          * This corrsponding event on the server returns the curve data inside its callback
          * routine.
          * @see [server: read raw curve data from postgres and send it to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve}
          */ 
        socket.on('getCurve',function(){
          /**
          * This namespace describes the function body of the server sided socket.io
          * interface
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve
          * 
          */
          pg(socket,"ThermoCalDataCurves",'sendCurve');          
        });
//------------------------------------------------------------------------------------------
// Start of getAudioFlPths event
//------------------------------------------------------------------------------------------

        /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected    
          * @event getAudioFlPths
          * @type {object}
          * @property {function} getStimData gets stimulation data for the simulation view from postgres    
          * @description get stimulation data as wav files and send it to the simulation view
          * &lt;br>Follow the link to find the details about the callback function.&lt;br>&lt;br>
          * [send stimulation data to client]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData}  
          */
        socket.on('getAudioFlPths',function(){
          /**
          * This namespace describes the function body of the server sided socket.io
          * interface
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected
          * @type {object}
          * @namespace c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData
          * 
          */

          /**     
          * @memberof c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData    
          * @function getWav
          * @param {string} socket socket object
          * @description triggers a query in the postgres database which eventually
          * eventually loads the found data &lt;br>
          * &lt;a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">link &lt;/a>
          * 
          * @see {@link module:e_getModelStimulationData_server}
          */
        new getWav(socket);
        });
//------------------------------------------------------------------------------------------
// End of getAudioFlPths event
//------------------------------------------------------------------------------------------        
        });        
   
}</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
